import "core-js/modules/es6.promise";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.array.iterator";
import "core-js/modules/es6.object.to-string";
import "core-js/modules/es6.string.iterator";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import "core-js/modules/es6.regexp.match";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from 'react';
var currentPage = '$$currentPage';
var df = 'default';

var PageProxy =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(PageProxy, _Component);

  function PageProxy() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      hasError: false
    };
    return _this;
  }

  var _proto = PageProxy.prototype;

  _proto.getPagePath = function getPagePath() {
    var _this$props = this.props,
        url = _this$props.match.url,
        _this$props$homePage = _this$props.homePage,
        homePage = _this$props$homePage === void 0 ? 'home' : _this$props$homePage;
    return url.substr(1) || homePage;
  };

  _proto.componentDidMount = function componentDidMount() {
    this.loadAsyncPages(this.getPagePath());
  } // componentWillReceiveProps(nextProps) {
  //   let currentPath = this.getPagePath(this.props);
  //   let nextPath = this.getPagePath(nextProps);
  //   if (currentPath !== nextPath) {
  //     this.loadAsyncPages(nextPath);
  //   }
  // }
  ;

  PageProxy.getDerivedStateFromError = function getDerivedStateFromError(error) {
    return {
      hasError: true,
      error: error
    };
  } // componentDidCatch(err, info) {
  //   this.warn(info.componentStack);
  // }
  ;

  _proto.renderPageElement = function renderPageElement(Loading) {
    var state = this.state;
    var pagePath = this.getPagePath();
    var Page = state[pagePath];

    if (Page) {
      var useLayout = Page.useLayout;
      this.useLayout = typeof useLayout === 'boolean' ? useLayout : true; //缓存当前useLayout的状态，进入下一个页面的时候避免发生layout的切换导致的闪动

      return [React.createElement(Page, this.props), this.useLayout];
    } //读取之前的layout状态，如果不存在就用true


    this.loadAsyncPages(pagePath);
    var ul = this.useLayout === 'boolean' ? this.useLayout : true;
    return [Loading ? React.createElement(Loading, null) : React.createElement("div", null, "\u52A0\u8F7D\u4E2D..."), ul];
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        ErrorComp = _this$props2.ErrorComp,
        Layout = _this$props2.Layout,
        LoadingComp = _this$props2.LoadingComp,
        props = _objectWithoutPropertiesLoose(_this$props2, ["ErrorComp", "Layout", "LoadingComp"]);

    if (this.state.hasError && ErrorComp) return React.createElement(ErrorComp, _extends({
      error: this.state.error
    }, props));

    var _this$renderPageEleme = this.renderPageElement(LoadingComp),
        pageElement = _this$renderPageEleme[0],
        useLayout = _this$renderPageEleme[1];

    if (!useLayout || !Layout) return pageElement;
    return React.createElement(Layout, this.props, pageElement);
  } // warn(msg, err) {
  //   if (err) throw err;
  //   else if (console && console.error) {
  //     console.error(msg);
  //   }
  // }
  ;

  _proto.loadAsyncPages = function loadAsyncPages(path) {
    var _this2 = this;

    var loadPage = import(
    /* webpackMode: "lazy", webpackChunkName: "[request]" */
    "_/src/pages/" + path + "/page-view");
    Promise.all([loadPage]).then(function (_ref) {
      var loadedModule = _ref[0];
      var needUpdate = false;
      var updateData = {};
      var PageComponent = loadedModule[df];

      if (PageComponent) {
        needUpdate = true;
        updateData[path] = PageComponent;
      }

      if (needUpdate) {
        _this2.setState(updateData);
      }
    }).catch(function (err) {
      console.error("from <Talent UI Page Proxy>\uFF1Afailed to load page, please check the page-view under <" + path + "> is exist ");
    });
  };

  return PageProxy;
}(Component);

export { PageProxy as default };